module type CharPQueueAbs =
   sig
     type priority = int         (* still concrete *)
     type char_queue            (* now abstract *)
     val empty : char_queue
     val insert : char_queue -> int -> char -> char_queue
     exception QueueIsEmpty
   end
   (*forgot about the ";;"; it is mainly used to terminate an input
    * in the ocaml toplevel; it doesn't hurt to use it,
    * but it is not common to put it in source code files *)
